VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "  "
   ClientHeight    =   4350
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7710
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   4350
   ScaleWidth      =   7710
   StartUpPosition =   2  'CenterScreen
   Begin VB.ListBox lstGroups 
      Appearance      =   0  'Flat
      Height          =   4125
      ItemData        =   "Form1.frx":0000
      Left            =   120
      List            =   "Form1.frx":001C
      TabIndex        =   1
      Top             =   120
      Width           =   2655
   End
   Begin VB.TextBox txtInfo 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      Height          =   4095
      Left            =   2880
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   4695
   End
   Begin VB.Menu mnuContext 
      Caption         =   " "
      Visible         =   0   'False
      Begin VB.Menu mnuCopy 
         Caption         =   ""
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuTag 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPrint 
         Caption         =   ""
         Shortcut        =   ^P
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents objSink As SWbemSink
Attribute objSink.VB_VarHelpID = -1
Private strComputer As String

Private Sub Form_Load()
    strComputer = "."
    lstGroups.ListIndex = 0
End Sub

Private Sub Form_Resize()
On Error GoTo err
    lstGroups.Height = Me.Height - 700
    txtInfo.Height = lstGroups.Height
    txtInfo.Width = Me.Width - 3100
    Exit Sub
err:
    Exit Sub
End Sub

Private Sub AddInfo(caption As String, value As String, Optional units As String)
    txtInfo.Text = txtInfo.Text & caption & ": " & value & " " & units & vbCrLf
End Sub

Private Sub lstGroups_Click()
    On Error Resume Next
    Dim objSWbemService As SWbemServices, colItems As SWbemObjectSet, objItem As SWbemObject
    Dim wmiDiskDrives As SWbemObjectSet, wmiDiskDrive As SWbemObject
    Dim wmiDiskPartitions As SWbemObjectSet, wmiDiskPartition As SWbemObject
    Dim wmiLogicalDisks  As SWbemObjectSet, wmiLogicalDisk As SWbemObject
    Dim strEscapedDeviceID As String
    Me.MousePointer = vbHourglass
    txtInfo.Text = ""
    Select Case lstGroups.ListIndex
        Case 0 '
            Set objSWbemService = GetObject( _
                "winmgmts:\\" & strComputer & "\ROOT\CIMV2")
            Set colItems = objSWbemService.ExecQuery( _
                "SELECT * FROM Win32_OperatingSystem", , 48)
                For Each objItem In colItems
                    AddInfo " ", objItem.caption
                    AddInfo "", objItem.Version
                    AddInfo "", objItem.Manufacturer
                    AddInfo "", objItem.RegisteredUser
                    AddInfo "", objItem.Organization
                    AddInfo " ", objItem.SerialNumber
                    AddInfo "  ", Round(CDbl(objItem.TotalVisibleMemorySize / 1024), 0), ""
                    txtInfo.Text = txtInfo.Text & vbCrLf
                Next
        Case 1 'BIOS
            Set objSWbemService = GetObject( _
                "winmgmts:\\" & strComputer & "\ROOT\CIMV2")
            Set colItems = objSWbemService.ExecQuery( _
                "SELECT * FROM Win32_BIOS", , 48)
                For Each objItem In colItems
                    AddInfo "", objItem.Description
                    AddInfo "", objItem.CurrentLanguage
                    AddInfo "", objItem.Manufacturer
                    txtInfo.Text = txtInfo.Text & vbCrLf
                Next
        Case 2 'DVD  CD-ROM
            Set objSWbemService = GetObject( _
                "winmgmts:\\" & strComputer & "\ROOT\CIMV2")
            Set colItems = objSWbemService.ExecQuery( _
                "SELECT * FROM Win32_CDROMDrive", , 48)
                For Each objItem In colItems
                    AddInfo "", objItem.Id
                    AddInfo " ", objItem.MediaType
                    AddInfo "", objItem.Manufacturer
                    txtInfo.Text = txtInfo.Text & vbCrLf
                Next
        Case 3 '
            Set objSWbemService = GetObject( _
                "winmgmts:\\" & strComputer & "\ROOT\CIMV2")
            Set colItems = objSWbemService.ExecQuery( _
                "SELECT * FROM Win32_VideoController", , 48)
                For Each objItem In colItems
                    AddInfo "", objItem.Description
                    AddInfo " ", objItem.VideoModeDescription
                    AddInfo " ", objItem.InstalledDisplayDrivers
                    AddInfo " ", objItem.DriverVersion
                    AddInfo " ", CDbl(objItem.AdapterRAM) / 1024 / 1024, " "
                    AddInfo "  ", objItem.MinRefreshRate, ""
                    AddInfo "  ", objItem.MaxRefreshRate, ""
                    txtInfo.Text = txtInfo.Text & vbCrLf
                Next
        Case 4 ' 
            Set objSWbemService = GetObject( _
                "winmgmts:\\" & strComputer & "\ROOT\CIMV2")
            Set wmiDiskDrives = objSWbemService.ExecQuery _
                ("SELECT Caption FROM Win32_DiskDrive")
                For Each wmiDiskDrive In wmiDiskDrives
                    AddInfo " ", wmiDiskDrive.caption
                    AddInfo "", ""
                    strEscapedDeviceID = Replace _
                        (wmiDiskDrive.DeviceID, "\", "\\", 1, -1, vbTextCompare)
                    Set wmiDiskPartitions = objSWbemService.ExecQuery _
                        ("ASSOCIATORS OF {Win32_DiskDrive.DeviceID=""" & _
                    strEscapedDeviceID & """} WHERE AssocClass = " & _
                        "Win32_DiskDriveToDiskPartition")
                   For Each wmiDiskPartition In wmiDiskPartitions
                       Set wmiLogicalDisks = objSWbemService.ExecQuery _
                           ("ASSOCIATORS OF {Win32_DiskPartition.DeviceID=""" & _
                               wmiDiskPartition.DeviceID & """} WHERE AssocClass = " & _
                                   "Win32_LogicalDiskToPartition")
                        For Each wmiLogicalDisk In wmiLogicalDisks
                            txtInfo.Text = txtInfo.Text & vbTab & wmiLogicalDisk.DeviceID & vbCrLf
                            AddInfo vbTab & vbTab & "", Round(CDbl(wmiLogicalDisk.Size) / 1024 / 1024, 0), ""
                            AddInfo vbTab & vbTab & "", Round(CDbl(wmiLogicalDisk.FreeSpace) / 1024 / 1024, 0), ""
                            AddInfo vbTab & vbTab & " ", wmiLogicalDisk.FileSystem
                            AddInfo vbTab & vbTab & "  ", wmiLogicalDisk.VolumeSerialNumber
                        Next
                   Next
                    txtInfo.Text = txtInfo.Text & vbCrLf
                Next
        Case 5 '
            Set objSWbemService = GetObject( _
                "winmgmts:\\" & strComputer & "\ROOT\CIMV2")
            Set colItems = objSWbemService.ExecQuery( _
                "SELECT * FROM Win32_Keyboard", , 48)
                For Each objItem In colItems
                    AddInfo "", objItem.Description
                    AddInfo "  ", objItem.NumberOfFunctionKeys
                    txtInfo.Text = txtInfo.Text & vbCrLf
                Next
        Case 6 '
            Set objSWbemService = GetObject( _
                "winmgmts:\\" & strComputer & "\ROOT\CIMV2")
            Set colItems = objSWbemService.ExecQuery( _
                "SELECT * FROM Win32_Printer", , 48)
                For Each objItem In colItems
                    AddInfo "", objItem.Name
                    AddInfo "", objItem.PortName
                    txtInfo.Text = txtInfo.Text & vbCrLf
                Next
        Case 7 '
            Set objSWbemService = GetObject( _
                "winmgmts:\\" & strComputer & "\ROOT\CIMV2")
            Set colItems = objSWbemService.ExecQuery( _
                "SELECT * FROM Win32_Processor", , 48)
                For Each objItem In colItems
                    AddInfo "", objItem.Name
                    AddInfo "", objItem.Version
                    AddInfo " ", objItem.AddressWidth
                    txtInfo.Text = txtInfo.Text & vbCrLf
                Next
    End Select
    Me.MousePointer = vbDefault
End Sub

Private Sub mnuCopy_Click()
    Clipboard.Clear
    Clipboard.SetText txtInfo.Text
End Sub

Private Sub mnuPrint_Click()
    Printer.Print txtInfo.Text
    Printer.EndDoc
End Sub

Private Sub txtInfo_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        txtInfo.Enabled = False
        txtInfo.Enabled = True
        Me.PopupMenu mnuContext
    End If
End Sub
